this.name					= "LaveAcademy";
this.author					= "Thargoid";
this.copyright				= "Creative Commons Attribution - Non-Commercial - Share Alike 3.0 license with clauses - see readme.txt.";
this.description			= "Control of new additions to the Lave (and other) systems";
this.version				= "1.33";

this.extraA = true;   //   Academies in all galaxies? If false only appear at Lave, nowhere else - ignore extraB
this.extraB = false;   //   Single or multiple academies if extraA set. False gives 1 per galaxy, true gives 5

this.oxpcSettings = {
	Info: {Name:this.name,Display:this.name,InfoB:"1 - If false only appear at Lave, nowhere else - ignore extraB.\n2 - Single or multiple academies if extraA set. False gives 1 per galaxy, true gives 5."},
	Bool0: {Name:"extraA",Def:true,Desc:"Academies in all galaxies?"},
	Bool1: {Name:"extraB",Def:false,Desc:"Multiple academies per galaxy."}
};

this.startUp = function()
	{ 
	if(missionVariables.laveAcademy_bestTargetTimeM == null)
		{ missionVariables.laveAcademy_bestTargetTimeM = 0; }
	if(missionVariables.laveAcademy_bestTargetTimeS == null)
		{ missionVariables.laveAcademy_bestTargetTimeS = 0; }
	if(missionVariables.laveAcademy_bestPilotScore == null)
		{ missionVariables.laveAcademy_bestPilotScore = 0; }
	if(missionVariables.laveAcademy_bestPilotTimeM == null)
		{ missionVariables.laveAcademy_bestPilotTimeM = 0; }
	if(missionVariables.laveAcademy_bestPilotTimeS == null)
		{ missionVariables.laveAcademy_bestPilotTimeS = 0; }
	if(missionVariables.laveAcademy_bestDockingScore == null)
		{ missionVariables.laveAcademy_bestDockingScore = 0; }
	if(missionVariables.laveAcademy_bestDockingTimeM == null)
		{ missionVariables.laveAcademy_bestDockingTimeM = 0; }
	if(missionVariables.laveAcademy_bestDockingTimeS == null)
		{ missionVariables.laveAcademy_bestDockingTimeS = 0; }
	this.deactivateWIS = false;
	this.setUpArrays();
	}

this.setUpArrays = function()
	{
	this.academyList = [0, 1, 2, 3, 4, 5, 6, 7]; // galaxies 0-7
	this.academyList[0] = [7, 173, 168, 133, 4]; // Lave, Esteonbi, Enonla, Esanbe, Xequerin
	this.academyList[1] = [24, 92, 210, 55, 194]; // Maesaron, Erenanri, Reveabe, Legeara, Tigebere
	this.academyList[2] = [58, 165, 106, 198, 164]; // Radiqu, Edxeri, Ceedleon, Atius,Rerebi
	this.academyList[3] = [13, 47, 130, 18, 122]; // Mavelege, Bemate, Cebitiza,  Mausra, Ensoor
	this.academyList[4] = [16, 193, 231, 92, 9]; // Zaaner, Vebi, Inenares, Azaenbi, Dioris
	this.academyList[5] = [151, 6, 85, 146, 240]; // Teesso, Oresmaa, Celaan, Ariqu, Inesbe
	this.academyList[6] = [189, 146, 130, 118, 37]; // Isdilaon, Aenbi, Ataer, Orreedon, Qutegequ
	this.academyList[7] = [177, 31, 211, 157, 20]; // Ceenza, Aarzari, Biatzate, Inbein, Oredrier
	this.singleList = [7, 24, 58, 13, 16, 151, 189, 177]; // array for when 1 academy per galaxy selected
	}

this.systemCheck = function(planetNum,galNum)	
	{
	if(!this.extraA) // academy at Lave only?
		{
		if(planetNum == 7 && galNum == 0)
			{ return true; }	
		else
			{ return false; }
		}
        else 
		{
		if(!this.extraB)	// 1 academy per galaxy
			{
			if(planetNum == this.singleList[galNum])
				{ return true; }	
			else
				{ return false; }
			}
		else	// 5 academies per galaxy
			{
			if(this.academyList[galNum].indexOf(planetNum) != -1)
				{ return true; }	
			else
				{ return false; }
			}
		}
	}

this.setUpSystem = function()
	{
	if(this.systemCheck(system.ID, galaxyNumber))
		{
		this.academyArray = system.shipsWithPrimaryRole("laveAcademy_academy"); 
			// find the academy
		this.wayBuoyArray = system.shipsWithPrimaryRole("laveAcademy_wayBuoy"); 
			// find the directional way buoy between main station & academy
		this.targetBuoyArray = system.shipsWithPrimaryRole("laveAcademy_targetBuoy"); 
			// find the buoy for the target practice course
		this.dockingBuoyArray = system.shipsWithPrimaryRole("laveAcademy_dockingBuoy"); 
			// find the buoy for the docking course
		this.pilotBuoyArray = system.shipsWithPrimaryRole("laveAcademy_pilotBuoy"); 
			// find the buoy for the piloting course			

		if(this.academyArray.length === 0)
			{ this.academyArray = system.addShips("laveAcademy_academy",1,[100000,100000,100000], 1000); }
		if(this.wayBuoyArray.length === 0)
			{ this.wayBuoyArray = system.addShips("laveAcademy_wayBuoy",1,[101000,101000,101000], 1000); }
		if(this.targetBuoyArray.length === 0)
			{ this.targetBuoyArray = system.addShips("laveAcademy_targetBuoy",1,[102000,102000,102000], 1000); }
		if(this.dockingBuoyArray.length === 0)
			{ this.dockingBuoyArray = system.addShips("laveAcademy_dockingBuoy",1,[103000,103000,103000], 1000); }
		if(this.pilotBuoyArray.length === 0)
			{ this.pilotBuoyArray = system.addShips("laveAcademy_pilotBuoy",1,[104000,104000,104000], 1000); }	

		this.academy = this.academyArray[0];
		this.academy.scannerDisplayColor1 = "greenColor";
		this.academy.scannerDisplayColor2 = "brownColor";
		this.academy.position = system.mainStation.position.add([0,50000,0]);	
		
		this.academy.setInterface("LaveAcademy",
			{ title: "Show syllabus",
			category: "Station",
			summary: "Display the courses available to undertake at the Academy.",
			callback: this.showCourses.bind(this) });		
		this.academy.setInterface("oolite-contracts-cargo",null);
		this.academy.setInterface("oolite-contracts-parcels",null);
		this.academy.setInterface("oolite-contracts-passengers",null);
//	Set the academy syllabus on the F4 screen, and remove the trunk ones for this station.
	
		this.wayBuoy = this.wayBuoyArray[0];		
		this.wayBuoy.position = system.mainStation.position.add([0,20000,0]);

		this.targetBuoy = this.targetBuoyArray[0];
		this.targetBuoy.position = this.academy.position.add([0,0,20000]);
		this.targetBuoy.AIState = "LIGHTS_OFF";
		
		this.dockingBuoy = this.dockingBuoyArray[0];
		this.dockingBuoy.position = this.academy.position.add([20000,0,0]);
		this.dockingBuoy.AIState = "LIGHTS_OFF";

		this.pilotBuoy = this.pilotBuoyArray[0];
		this.pilotBuoy.position = this.academy.position.add([-20000,0,0]);
		this.pilotBuoy.AIState = "LIGHTS_OFF";
		}
	}

this.showCourses = function()
	{ 
	mission.runScreen({title: "Academy Syllabus", messageKey: "laveAcademy_examOffer", choicesKey:"laveAcademy_offerChoice"}, this.choseExam); 
	}	
	
this.shipLaunchedFromStation = function()
	{
	if(this.systemCheck(system.ID, galaxyNumber) && this.deactivateWIS)
		{
		if(worldScripts["Welcome Information Script"]) 
		// if Welcome Mat is loaded & running, disable it to stop data messages with the course buoys
			{
			if(worldScripts["Welcome Information Script"].welcomeTimer.isRunning)
				{
				worldScripts["Welcome Information Script"].welcomeTimer.stop();
				if(player.ship.equipmentStatus("EQ_WELCOME_MAT") == "EQUIPMENT_OK")
					{ player.consoleMessage("Planetary Information System deactivated for exam.",6); }
				}
			}
		this.deactivateWIS = false;
		}
	}

this.shipWillLaunchFromStation = function(station)
	{
	this.setUpSystem()
	if(station.hasRole("laveAcademy_academy"))
		{
		missionVariables.trumbles = missionVariables.laveAcademy_storeTrumble; 
		// reactivate the trumble mission if it was available before docking.

		switch(missionVariables.laveAcademyExam) // Get the course started by setting the buoys AI states
			{
			case "TARGET":
				{
				this.targetBuoy.AIState = "LIGHTS_ON";
				this.dockingBuoy.AIState = "LIGHTS_OFF";
				this.pilotBuoy.AIState = "LIGHTS_OFF";
				this.buoyID = this.targetBuoy;
				this.deactivateWIS = true;
				if(this.buoyTimer)
					{ this.buoyTimer.start(); }
				else
					{ this.buoyTimer = new Timer(this, this.checkBuoyDistance, 0, 10); }
				break;
				}
			case "DOCKING":
				{
				this.targetBuoy.AIState = "LIGHTS_OFF";
				this.dockingBuoy.AIState = "LIGHTS_ON";
				this.pilotBuoy.AIState = "LIGHTS_OFF";
				this.buoyID = this.dockingBuoy;
				this.deactivateWIS = true;
				if(this.buoyTimer)
					{ this.buoyTimer.start(); }
				else
					{ this.buoyTimer = new Timer(this, this.checkBuoyDistance, 0, 10); }
				break;
				}
			case "PILOT":
				{
				this.targetBuoy.AIState = "LIGHTS_OFF";
				this.dockingBuoy.AIState = "LIGHTS_OFF";
				this.pilotBuoy.AIState = "LIGHTS_ON";
				this.buoyID = this.pilotBuoy;
				this.deactivateWIS = true;
				if(this.buoyTimer)
					{ this.buoyTimer.start(); }
				else
					{ this.buoyTimer = new Timer(this, this.checkBuoyDistance, 0, 2); }
				break;
				}
			default:
				{
				this.targetBuoy.AIState = "LIGHTS_OFF";
				this.dockingBuoy.AIState = "LIGHTS_OFF";
				this.pilotBuoy.AIState = "LIGHTS_OFF";
				this.deactivateWIS = false;
				break;
				}	
			} 
		}
	}

this.shipExitedWitchspace = function()
	{
	if(this.systemCheck(system.ID, galaxyNumber))
		{ this.setUpSystem(); }
	}

this.stopTimers = function()
	{
	if(this.buoyTimer)
		{ this.buoyTimer.stop(); }
	if(this.targetTimer)
		{ this.targetTimer.stop(); }
	if(this.pilotTimer)
		{ this.pilotTimer.stop(); }
	if(this.dockingTimer)
		{ this.dockingTimer.stop(); }
	if(worldScripts["LaveAcademy_targetBuoy"] && worldScripts["LaveAcademy_targetBuoy"].launchCheckTimer)
		{ worldScripts["LaveAcademy_targetBuoy"].launchCheckTimer.stop(); }
	if(worldScripts["LaveAcademy_dockingBuoy"] && worldScripts["LaveAcademy_dockingBuoy"].launchCheckTimer)
		{ worldScripts["LaveAcademy_dockingBuoy"].launchCheckTimer.stop(); }
	if(worldScripts["LaveAcademy_pilotBuoy"] && worldScripts["LaveAcademy_pilotBuoy"].pilotCourseTimer)
		{ worldScripts["LaveAcademy_pilotBuoy"].pilotCourseTimer.stop(); }
	if(worldScripts["LaveAcademy_pilotBuoy"] && worldScripts["LaveAcademy_pilotBuoy"].pilotFinishTimer)
		{ worldScripts["LaveAcademy_pilotBuoy"].pilotFinishTimer.stop(); }
	}

this.shipWillEnterWitchspace = this.shipDied = function()
	{
	if(this.systemCheck(system.ID, galaxyNumber))
		{
		this.stopTimers();
		this.deactivateWIS = false;
		this.targetBuoy.explode();
		this.dockingBuoy.explode();
		this.pilotBuoy.explode();
		missionVariables.laveAcademyExam = null;
		if(worldScripts["Welcome Information Script"]) // if Welcome Mat has been disabled earlier, restart it
			{
			if(!worldScripts["Welcome Information Script"].welcomeTimer.isRunning)
				{
				worldScripts["Welcome Information Script"].welcomeTimer.start();
				if(player.ship.equipmentStatus("EQ_WELCOME_MAT") == "EQUIPMENT_OK")
					{ player.consoleMessage("Planetary Information System restarted.",6); }
				}
			}
		}
	}

this.shipWillDockWithStation = function(station)
	{
	if(this.systemCheck(system.ID, galaxyNumber))
		{
		this.deactivateWIS = false;
		missionVariables.laveAcademyExam = null;
		this.stopTimers();
		}

	if(station.hasRole("laveAcademy_academy")) // stop the trumble mission offering whilst docked at the academy
		{
		missionVariables.laveAcademy_storeTrumble = missionVariables.trumbles;
		missionVariables.trumbles = "";
		} 
	}

this.checkBuoyDistance = function()
	{
	this.buoyDistance = player.ship.position.distanceTo(this.buoyID.position); // how far the player ship is from the buoy
	if(this.buoyDistance < 1000) // if we're within 1000m.
		{
		this.buoyTimer.stop();
		this.buoyID.AIState = "START_EXAM";
		}
	}

this.guiScreenChanged = function()
	{
	if(!player.ship.docked) // for GUI screen changes whilst in flight, which we can ignore
		{ return; }

	if(!player.ship.dockedStation.hasRole("laveAcademy_academy")) // if we're not at Lave Academy
		{ return; }

	// replace marketplace screen with exam offering mission screen
	if(guiScreen == "GUI_SCREEN_MARKET")
		{ this.showCourses(); }
	}	


this.choseExam = function (examChoice)
	{
	switch(examChoice)
		{
		case "ACADEMY_1_TARGET":
			{
			mission.runScreen({title:"Gunnery Exam", messageKey:"laveAcademy_targetInfo", choicesKey:"laveAcademy_targetYesNo"}, this.examYesNo);
			break;
			}
		case "ACADEMY_2_PILOT":
			{
			mission.runScreen({title:"Piloting Exam", messageKey:"laveAcademy_pilotInfo", choicesKey:"laveAcademy_pilotYesNo"}, this.examYesNo);
			break;
			}
		case "ACADEMY_3_DOCKING":
			{
			mission.runScreen({title: "Docking Exam", messageKey:"laveAcademy_dockingInfo", choicesKey:"laveAcademy_dockingYesNo"}, this.examYesNo);
			break;
			}
		case "ACADEMY_4_RESET":
			{
			missionVariables.laveAcademyExam = null;
			missionVariables.laveAcademy_bestTargetTimeM = 0;
			missionVariables.laveAcademy_bestTargetTimeS = 0;
			missionVariables.laveAcademy_bestPilotTimeM = 0;
			missionVariables.laveAcademy_bestPilotTimeS = 0;
			missionVariables.laveAcademy_bestDockingScore = 0;
			missionVariables.laveAcademy_bestDockingTimeM = 0;
			missionVariables.laveAcademy_bestDockingTimeS = 0;
			mission.runScreen({title: "Academy Syllabus", messageKey: "laveAcademy_examOffer", choicesKey:"laveAcademy_offerChoice"}, this.choseExam);
			break;
			}
		case "ACADEMY_5_DECLINE":
			{
			missionVariables.laveAcademyExam = null;
			break;
			}
		}
	}
	
this.examYesNo = function(selection)
	{
	switch(selection)
		{
		case "ACADEMY_1_TARGETYES":
				{
				missionVariables.laveAcademyExam = "TARGET";
				break;
				}
		case "ACADEMY_2_TARGETNO":
				{
				mission.runScreen({title: "Academy Syllabus", messageKey: "laveAcademy_examOffer", choicesKey:"laveAcademy_offerChoice"}, this.choseExam);
				break;
				}
		case "ACADEMY_1_PILOTYES":
				{
				missionVariables.laveAcademyExam = "PILOT";
				break;
				}
		case "ACADEMY_2_PILOTNO":
				{
				mission.runScreen({title: "Academy Syllabus", messageKey: "laveAcademy_examOffer", choicesKey:"laveAcademy_offerChoice"}, this.choseExam);
				break;
				}
		case "ACADEMY_1_DOCKINGYES":
				{
				missionVariables.laveAcademyExam = "DOCKING";
				break;
				}
		case "ACADEMY_2_DOCKINGNO":
				{
				mission.runScreen({title: "Academy Syllabus", messageKey: "laveAcademy_examOffer", choicesKey:"laveAcademy_offerChoice"}, this.choseExam);
				break;
				}
			default:
				{
				missionVariables.laveAcademyExam = null;
				break;
				}	
		} 
	}
