this.name					= "LaveAcademy_targetDrone";
this.author					= "Thargoid";
this.copyright				= "Creative Commons Attribution - Non-Commercial - Share Alike 3.0 license with clauses - see readme.txt.";
this.description			= "Script for the target drones in the shooting gallery of Lave Academy";
this.version				= "1.2";

this.shipSpawned = function()
	{ 
	this.ship.scannerDisplayColor1 = "yellowColor";
	this.ship.scannerDisplayColor2 = "whiteColor";
	if(!missionVariables.laveAcademy_droneLifetime)
		{
		log("Lave Academy", "***** ALERT - Target drone lifetime mission variable not set! *****")
		missionVariables.laveAcademy_droneLifetime = 45;
		}
	this.destructTimer = new Timer(this, this.selfDestruct, missionVariables.laveAcademy_droneLifetime);  // set the drone's lifetime.
	this.targetBuoyArray = system.shipsWithPrimaryRole("laveAcademy_targetBuoy");
	this.targetBuoy = this.targetBuoyArray[0];
	}

this.shipDied = function(whom, why)
	{
	if(this.destructTimer && this.destructTimer.isRunning && whom && whom.isPlayer) 
		{
		this.destructTimer.stop();
		player.score -= 1; // as this is an exam, the drones shouldn't count as kills for rank etc.
		player.commsMessage("Drone destroyed.", 5);
		}
	}

this.selfDestruct = function()
	{
	if(!this.ship)
		{
		return;
		}

	if(!missionVariables.laveAcademy_droneAbort && !player.ship.docked) // if the exam is still going but the player didn't kill the drone
		{
		player.commsMessage("Drone missed.", 5);	
		}
	this.ship.explode();
	}

this.findBuoy = function()
	{
	if(!this.ship)
		{
		return;
		}

	this.buoyDistance = this.ship.position.distanceTo(this.targetBuoy.position); // how far the drone is from the buoy
	if(this.buoyDistance > 24000) // if the drone is going out of scanner range
		{
		this.ship.AIState = "BACK_TO_BUOY";
		}
	}

this.playerWillEnterWitchspace = function()
	{
	if(this.destructTimer)
		{
		this.destructTimer.stop();
		}
	}